; scripts for  delphi and jaws 3.7
; written by Jos Vilmar Estcio de Souza vilmar@informal.com.br
; version 0.1
; please contact me  if you have suggestions or if you   find bugs 

; some features  that I tried to implement  and I hope they are working!

; in form design, if you press tab, ShiftTab, escape  or the arrow keys,  jaws try to read the actual component name.

; eliminate  some conflicts  between keys used by jaws and delphi

; when you press the alt key,  jaws normaly don't anounces the menu bar. We tried to solve this problem!

; there is a function  to anounce the actual component name in form design and in  object inspector.
; this function is attached to  Ctrl+Shift+/

; in object  inspector, the Up and DOWN arrows  reads the properties values of the actual component.

include "hjglobal.jsh" ; default HJ global variables
Include "hjconst.jsh" ; default HJ constants
Include "default.jsm" ; message file

globals handle PrevMessage,
             int IndMenu,
             int FlagMenu,
    int FlagM,
string LastMenu,
             string MenuName

; function to compare 2 strings. returns true if they are equals 
Int Function StrCmp (string str1, string str2)

return (StringLength (str1) == StringLength (str2) &&
StringUpper (str1) == StringUpper (str2))

EndFunction

    ; function to test if we are in form design
Int Function INFormDesign (handle WindowHandle)
var string s

let s= GetWindowClass (windowhandle)
return (IsPCCursor () &&
GetControlID (WindowHandle) == 0 &&
StrCmp (SubString (s, 1, 1), "t") &&
!StrCmp(s, "TAppBuilder") &&
!StrCmp(s, "TEditWindow") &&
GetWindowType (WindowHandle) != "menu") 

EndFunction

;function to test if we are in the editor
Int Function InEditor (handle WindowHandle)

Return (StrCmp(GetWindowClass (WindowHandle), "TEditControl"))

EndFunction

;function to test if we are in the Object Inspector
Int Function InObjectInspector (handle WindowHandle)
var string s

let s= GetWindowClass (WindowHandle)

Return(IsPCCursor () &&
(StrCmp(s, "TPropInspEdit")||
StrCmp(s, "TPropSelection"))) 

EndFunction

;function to test if we are in  the menu mode
Int Function InMenuMode (handle WindowHandle)
var string s

let s= GetWindowClass (WindowHandle)
Return(IsPCCursor () &&
(StrCmp(s, "TAppBuilder") || StrCmp(s, "TDockToolBar")))

EndFunction

;reassigns  the CtrlDownArrow in the  Object Inspector
Script ControlDownArrow ()
if InObjectInspector (GetCurrentWindow ()) then
;SayCurrentScriptKeyLabel ()
TypeCurrentScriptKey ()
Return
EndIf

PerformScript ControlDownArrow()

EndScript

;reassigns  the AltDownArrow in the  Object Inspector
Script AltDownArrow ()
if InObjectInspector (GetCurrentWindow ()) then
;SayCurrentScriptKeyLabel ()
TypeCurrentScriptKey ()
Return
EndIf

PerformScript OpenListBox()

EndScript

;reassigns  the CtrlF12
Script ControlF12 ()

SayCurrentScriptKeyLabel ()
TypeCurrentScriptKey ()

EndScript

;reassigns  the ShiftC  in the editor
Script ControlShiftC ()

if (InEditor (GetCurrentWindow ())) then
SayCurrentScriptKeyLabel ()
TypeCurrentScriptKey ()
Return
EndIf

PerformScript SayProgramComments()

EndScript

; reassigns  the delete key
Script DeleteKey ()

if INFormDesign (GetCurrentWindow () ) then
TypeCurrentScriptKey ()
SayCurrentScriptKeyLabel ()
Pause ()
ReadComponentName ()
Return
EndIf

PerformScript JawsDelete()

EndScript

;anounces  the current component name or reads the parent window of a button
Script AnnounceComponentName ()
var handle hw
var handle p

let hw= GetCurrentWindow ()
if INFormDesign (hw) || InObjectInspector (hw)then
ReadComponentName ()
Return
EndIf

if (GetWindowClass (hw) == "TButton") then
let p= GetParent (hw)
SayWindow (p, 0)
EndIf

EndScript

; tries  to get  the name of the  current component.
String Function GetComponentName ()
var string s,
    handle Hw

let Hw= GetCurrentWindow ()
if (not INFormDesign (hw)) && (not InObjectInspector (hw)) then 
Return ""
EndIf

SpeechOff ()
if INFormDesign (hw) then
EnterKey ()
Pause ()
EndIf
if (!InObjectInspector (GetCurrentWindow ())) then
SpeechOn ()
Return ""
EndIf

SaveCursor ()
RouteInvisibleToPc ()
InvisibleCursor ()
JAWSHome ()
JAWSPageUp ()
NextLine ()
let s= GetLine ()
RestoreCursor ()
if INFormDesign (hw) then
EnterKey ()
Pause ()
EndIf

SpeechOn ()
Return s

EndFunction

; reads  the name of the current  component
Void Function ReadComponentName ()

SayUsingVoice (VCTX_MESSAGE, GetComponentName (), OT_LINE)

EndFunction

; reassigns  the TabKey
Script TabKey ()
var handle hw

let hw= GetCurrentWindow ()
if INFormDesign (hw) then
TypeCurrentScriptKey ()
SayCurrentScriptKeyLabel ()
Pause ()
ReadComponentName ()
Pause ()
Return
EndIf

PerformScript Tab()

EndScript

Script shiftTabKey ()

if INFormDesign (GetCurrentWindow () ) then
TypeCurrentScriptKey ()
SayCurrentScriptKeyLabel ()
Pause ()
ReadComponentName ()
Return
EndIf

PerformScript ShiftTab()

EndScript

Script RightArrow ()
var handle cw

let cw= GetCurrentWindow ()
let FlagM= 0
if INFormDesign (cw) then
TypeCurrentScriptKey ()
;SayCurrentScriptKeyLabel ()
Pause ()
ReadComponentName ()
Return
EndIf

PerformScript SayNextCharacter()

EndScript

Script LeftArrow ()
var handle cw

let cw= GetCurrentWindow ()
let FlagM= 0
if INFormDesign (cw) then
TypeCurrentScriptKey ()
;SayCurrentScriptKeyLabel ()
Pause ()
ReadComponentName ()
Return
EndIf

PerformScript SayPriorCharacter()

EndScript

Script DownArrow ()

if INFormDesign (GetCurrentWindow () ) then
TypeCurrentScriptKey ()
;SayCurrentScriptKeyLabel ()
Pause ()
ReadComponentName ()
Return
EndIf

PerformScript SayNextLine()

EndScript

Script UpArrow ()

if INFormDesign (GetCurrentWindow () ) then
TypeCurrentScriptKey ()
;SayCurrentScriptKeyLabel ()
Pause ()
ReadComponentName ()
Return
EndIf

PerformScript SayPriorLine()

EndScript

Void Function ProcessMenu (handle WinHandle, int mode)

If (mode == MENU_ACTIVE) then
let FlagMenu= MENU_ACTIVE
		SayMessage (ot_jaws_message, msg57_L) ;"Menu active"
Return
EndIf

If (mode == MENUBAR_ACTIVE) then
let FlagMenu= MENUBAR_ACTIVE
SayMessage (ot_jaws_message, msg56_L) ;"	Menu bar"
let LastMenu= ""
let FlagM= 0
Return
EndIf

If (mode == MENU_INACTIVE) then
if InMenuMode (WinHandle) then
		SayMessage (ot_jaws_message, msg59_L) ;"Leaving menus"
let FlagMenu= MENUBAR_ACTIVE
SayMessage (ot_jaws_message, msg56_L) ;"	Menu bar"
SayMessage (ot_jaws_message, MenuName)
else
let FlagMenu= MENU_INACTIVE
SayMessage (ot_jaws_message, msg58_L) ;"leaving menu bar"
EndIf
Return
EndIf

EndFunction

Void Function MenuModeEvent (handle WinHandle, int mode)

ProcessMenu (WinHandle, mode)

EndFunction

Void Function AnnounceObject (handle FocusWindow)
var handle hw

let hw= GetCurrentWindow ()
if InObjectInspector (hw) then
RefreshWindow (FocusWindow)
Pause ()
;SayWindowTypeAndText (GetTopLevelWindow (FocusWindow))
;ReadComponentName ()
;SayWindowTypeAndText (FocusWindow)
Return
EndIf

if InEditor (hw) then
SayWindowTypeAndText (GetRealWindow (FocusWindow))
Return
EndIf
;sayWindowTypeAndText (GetRealWindow (FocusWindow))
SayWindowTypeAndText (FocusWindow)

if INFormDesign (FocusWindow) then
ReadComponentName ()
EndIf

EndFunction

Function FocusChangedEvent (handle FocusWindow, handle PrevWindow)
var handle p

;if GetWindowClass (FocusWindow) == "TButton" then
;let p= GetParent (FocusWindow)
;if p != PrevMessage && GetWindowClass (p) == "TMessageForm"then
;SayWindow (p, 0)
;let PrevMessage= p
;Else
;AnnounceObject (GetParent (FocusWindow))
;EndIf
;Else
If  InMenuMode (FocusWindow) then
if FlagMenu != MENUBAR_ACTIVE then
MenuModeEvent (FocusWindow, MENUBAR_ACTIVE)
EndIf
Return
EndIf

if InMenuMode (PrevWindow) then
if FlagMenu != MENU_INACTIVE then
MenuModeEvent (FocusWindow, MENU_INACTIVE)
EndIf
EndIf
if flagmenu == MENUBAR_ACTIVE then
Return
EndIf

AnnounceObject (FocusWindow)

EndFunction

Script ControlTab ()

if InObjectInspector (GetCurrentWindow ()) then
TypeCurrentScriptKey ()
Pause ()
SayWindowTypeAndText (GetCurrentWindow ())
Return
EndIf

PerformScript NextDocumentWindow()

EndScript

Void Function NewTextEvent (handle hwnd, string buffer, int nAttributes,
int nTextColor, int nBackgroundColor, int nEcho, string sFrameName)

if (ProcessSelectText(nAttributes,buffer)) then
	return
endIf

if InMenuMode (hwnd) then
let MenuName= StringSegment (buffer, " ", 1)
If FlagMenu == MENUBAR_ACTIVE then
if LastMenu !=  MenuName && FlagM!= 1 then
SayMessage (ot_jaws_message, MenuName)
let LastMenu= MenuName
let FlagM= 1
EndIf
EndIf

Return
EndIf

NewTextEvent(hwnd, buffer, nAttributes, nTextColor, NBackgroundColor, nEcho, sFrameName)

EndFunction

Script EscapeKey ()

if INFormDesign (GetCurrentWindow ()) then
TypeCurrentScriptKey ()
SayCurrentScriptKeyLabel ()
Pause ()
ReadComponentName ()
Return
EndIf

PerformScript UpALevel()

EndScript
